> For the complete documentation index, see [llms.txt](https://developers-apps-in-toss.toss.im/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-zh/sdk/domains-api/device/device.getlocation.md).

# Device.getLocation

> 函数式 API `getCurrentLocation`也可以这样使用同样的功能。

### 功能说明

获取设备的当前位置一次。用于地图、天气、查找门店等需要当前位置时。若要持续检测位置变化， `Device.subscribeLocation`请使用它。

如果没有位置权限， `GetCurrentLocationPermissionError`会发生。 `Device.getLocation.getPermission()` / `Device.getLocation.openPermissionDialog()`可以用来确认并请求权限。

### 类型

```ts
Device.getLocation(options: GetCurrentLocationOptions): Promise<Location>;
```

**Params**

```ts
enum Accuracy {
  Lowest = 1, // 误差范围约 3KM 以内
  Low = 2, // 误差范围约 1KM 以内
  Balanced = 3, // 误差范围数百米以内
  High = 4, // 误差范围约 10M 以内
  Highest = 5,
  BestForNavigation = 6,
}

type GetCurrentLocationOptions = {
  accuracy: Accuracy;
};
```

**Response**

```ts
type Location = {
  accessLocation?: "FINE" | "COARSE"; // 仅 Android
  timestamp: number;
  coords: {
    latitude: number;
    longitude: number;
    altitude: number;
    accuracy: number;
    altitudeAccuracy: number;
    heading: number;
  };
};
```

### 错误

错误会以类的形式抛出 — `error instanceof GetCurrentLocationPermissionError`来识别。该类可在 `@apps-in-toss/web-framework`中导入。

| 错误类                                 | 说明                                                            |
| ----------------------------------- | ------------------------------------------------------------- |
| `GetCurrentLocationPermissionError` | 表示位置权限被拒绝。 `Device.getLocation.openPermissionDialog()`可以重新请求。 |

### 示例代码

```js
import {
  Accuracy,
  Device,
  GetCurrentLocationPermissionError,
} from "@apps-in-toss/web-framework";

async function showCurrentPosition() {
  try {
    const location = await Device.getLocation({ accuracy: Accuracy.Balanced });
    console.log(location.coords.latitude, location.coords.longitude);
  } catch (error) {
    if (error instanceof GetCurrentLocationPermissionError) {
      console.warn("没有位置权限。");
      return;
    }
    console.error(error);
  }
}

document
  .getElementById("get-location")
  .addEventListener("click", showCurrentPosition);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-zh/sdk/domains-api/device/device.getlocation.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
